/*
 * Copyright IBM Corp. and others 1991
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution
 * and is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] https://openjdk.org/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
 */

/**
 * WARNING!!! GENERATED FILE
 *
 * This class is generated.
 * Do not use the Eclipse "Organize Imports" feature on this class.
 *
 * It can contain user content, but that content must be delimited with the
 * the tags
 * [BEGIN USER IMPORTS]
 * [END USER IMPORTS]
 *
 * or
 *
 * [BEGIN USER CODE]
 * [END USER CODE]
 *
 * These tags are entered as comments.  Characters before [ and after ] are ignored.
 * Lines between the tags are inserted into the newly generated file.
 *
 * IMPORTS are combined and inserted above newly generated imports.  CODE is combined
 * and inserted immediately after the class declaration
 *
 * All lines outside these tags are lost and replaced with newly generated code.
 */
package com.ibm.j9ddr.vm29.pointer.generated;

/*[BEGIN USER IMPORTS]*/
/*[END USER IMPORTS]*/

import com.ibm.j9ddr.CorruptDataException;
import com.ibm.j9ddr.vm29.pointer.*;
import com.ibm.j9ddr.vm29.structure.*;
import com.ibm.j9ddr.vm29.types.*;

/**
 * Structure: procattr_tPointer
 *
 * A generated implementation of a VM structure
 *
 * This class contains generated code and MAY contain hand written user code.
 *
 * Hand written user code must be contained at the top of
 * the class file, specifically above
 * the comment line containing WARNING!!! GENERATED CODE
 *
 * ALL code below the GENERATED warning will be replaced with new generated code
 * each time the PointerGenerator utility is run.
 *
 * The generated code will provide getters for all elements in the procattr_tPointer
 * structure.  Where possible, meaningful return types are inferred.
 *
 * The user may add methods to provide meaningful return types where only pointers
 * could be automatically inferred.
 */
@com.ibm.j9ddr.GeneratedPointerClass(structureClass=procattr_t.class)
public class procattr_tPointer extends StructurePointer {

	// NULL
	public static final procattr_tPointer NULL = new procattr_tPointer(0);

/*[BEGIN USER CODE]*/
/*[END USER CODE]*/

	// Do not call this constructor.  Use static method cast instead.
	protected procattr_tPointer(long address) {
		super(address);
	}

	public static procattr_tPointer cast(AbstractPointer structure) {
		return cast(structure.getAddress());
	}

	public static procattr_tPointer cast(UDATA udata) {
		return cast(udata.longValue());
	}

	public static procattr_tPointer cast(long address) {
		if (address == 0) {
			return NULL;
		}
		return new procattr_tPointer(address);
	}

	public procattr_tPointer add(long count) {
		return procattr_tPointer.cast(address + (procattr_t.SIZEOF * count));
	}

	public procattr_tPointer add(Scalar count) {
		return add(count.longValue());
	}

	public procattr_tPointer addOffset(long offset) {
		return procattr_tPointer.cast(address + offset);
	}

	public procattr_tPointer addOffset(Scalar offset) {
		return addOffset(offset.longValue());
	}

	public procattr_tPointer sub(long count) {
		return procattr_tPointer.cast(address - (procattr_t.SIZEOF * count));
	}

	public procattr_tPointer sub(Scalar count) {
		return sub(count.longValue());
	}

	public procattr_tPointer subOffset(long offset) {
		return procattr_tPointer.cast(address - offset);
	}

	public procattr_tPointer subOffset(Scalar offset) {
		return subOffset(offset.longValue());
	}

	public procattr_tPointer untag(long mask) {
		return procattr_tPointer.cast(address & ~mask);
	}

	public procattr_tPointer untag() {
		return untag(UDATA.SIZEOF - 1);
	}

	protected long sizeOfBaseType() {
		return procattr_t.SIZEOF;
	}

	// Implementation methods

	// uchar aixthread_hrt
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_aixthread_hrtOffset_", declaredType="uchar")
	public U8 aixthread_hrt() throws CorruptDataException {
		return new U8(getByteAtOffset(procattr_t._aixthread_hrtOffset_));
	}

	// uchar aixthread_hrt
	public U8Pointer aixthread_hrtEA() throws CorruptDataException {
		return U8Pointer.cast(nonNullFieldEA(procattr_t._aixthread_hrtOffset_));
	}

	// uchar core_mmap
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_core_mmapOffset_", declaredType="uchar")
	public U8 core_mmap() throws CorruptDataException {
		return new U8(getByteAtOffset(procattr_t._core_mmapOffset_));
	}

	// uchar core_mmap
	public U8Pointer core_mmapEA() throws CorruptDataException {
		return U8Pointer.cast(nonNullFieldEA(procattr_t._core_mmapOffset_));
	}

	// uchar core_naming
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_core_namingOffset_", declaredType="uchar")
	public U8 core_naming() throws CorruptDataException {
		return new U8(getByteAtOffset(procattr_t._core_namingOffset_));
	}

	// uchar core_naming
	public U8Pointer core_namingEA() throws CorruptDataException {
		return U8Pointer.cast(nonNullFieldEA(procattr_t._core_namingOffset_));
	}

	// uchar core_shm
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_core_shmOffset_", declaredType="uchar")
	public U8 core_shm() throws CorruptDataException {
		return new U8(getByteAtOffset(procattr_t._core_shmOffset_));
	}

	// uchar core_shm
	public U8Pointer core_shmEA() throws CorruptDataException {
		return U8Pointer.cast(nonNullFieldEA(procattr_t._core_shmOffset_));
	}

	// uchar ha_critical
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_ha_criticalOffset_", declaredType="uchar")
	public U8 ha_critical() throws CorruptDataException {
		return new U8(getByteAtOffset(procattr_t._ha_criticalOffset_));
	}

	// uchar ha_critical
	public U8Pointer ha_criticalEA() throws CorruptDataException {
		return U8Pointer.cast(nonNullFieldEA(procattr_t._ha_criticalOffset_));
	}

}
